<?php
/**
 * @copyright (c) Kufer Software GmbH, Oderstraße 7, D-84453 Mühldorf
 */

namespace Kufer\Web\KuferTools\Teilnehmer\ZsaTeilnehmerUebersicht\AendereBelegung;

class AendereBelegungController extends \Kufer\Web\KuferTools\Basis\Controller\ToolController
{
  protected function getUseCase(): \Kufer\Web\KuferTools\Basis\UseCase\UseCase
  {
    return new AendereBelegungUseCase(
      $this->getRequestObj()
    );
  }

  protected function getRequestObj()
  {
    $request = new AendereBelegungRequest();
    $request->bid = \GetOperations::getVarValue('bid');
    $request->bkbvtnId = \GetOperations::getVarValue('bkbvtn');

    $request->prioanm = \PostOperations::getVarValue('prioanm');
    $request->bemerkung = \PostOperations::getVarValue('bemerkung');
    $request->genehmigen = \PostOperations::getVarValue('genehmigen') == 'true';

    return $this->handleXsrf($request, $this->getActionVal(), $request->bid);
  }

  protected function getPresenter($pUseCaseResponse)
  {
    return null;
  }

  protected function getControllerToForward($pUseCaseResponse)
  {
    if (\GetOperations::getVarValue('von') == 'anmeldung') {
      return new \Kufer\Web\KuferTools\Teilnehmer\ZsaAnmeldung\BelegungsUebersicht\BelegungsUebersichtNachAbsendenController($pUseCaseResponse->statusCode);
    } elseif (\GetOperations::isDefined('toolAnm')) {
      return new \Kufer\Web\KuferTools\Teilnehmer\ZsaAnmeldung\TeilnehmerDetails\TeilnehmerDetailsNachAbsendenController($pUseCaseResponse->bid, $pUseCaseResponse->statusCode);
    } else {
      return new \Kufer\Web\KuferTools\Teilnehmer\ZsaTeilnehmerUebersicht\TeilnehmerDetails\TeilnehmerDetailsNachAbsendenController($pUseCaseResponse->bkbvtnId, $pUseCaseResponse->statusCode);
    }
  }
}